<?php

   include_once('project_defs.php');
   include_once('MySQLAdapterProjectManager.php');
   $login_timeout_minutes = 15;
   
   class User {
      private $_db_interface;
      private $_login;
      private $_person_id;
      
      private $_session_ticket;
      
      function __construct(MySQLAdapterProjectManager $db_interface, $create_new, $login,
       $session_ticket = '', $password = '') {
         $this->db_interface = $db_interface;
         $this->profile = array();
         if (!$login) throw new Exception('Required login parameter is missing or empty');
         $this->login = $login;
         if ($session_ticket) {
            $ticket_current = $this->check_session_ticket($login, $session_ticket);
            if (!$ticket_current) {
               throw new Exception('Expired or invalid login');
            }
            $this->load_existing_user_info();
         } else {
            $session_ticket = $this->authenticate ($login, $password);
            if (!$session_ticket) {
               throw new Exception ('Incorrect user name or password');
            }
            $this->load_existing_user_info();
         }
      }
      
      function get_by_login($login) {
         $db_inteface = new MySQLAdapterProjectManager();
         $query = 'select person_guid from user where username = ' . md5($login);
         $result = $db_inteface->db_get_first($query);
         $id = $result['person_guid'];
         $user = new User($db_inteface, FALSE, $id);
         return $user;
      }
      
      public function check_session_ticket ($login, $session_ticket) {
         global $login_timeout_minutes;
         
         $db_interface = new MySQLAdapterProjectManager();
         
         $current_timestamp = time();
         $last_valid_timestamp = $current_timestamp - (60 * $login_timeout_minutes);
         $ticket_good = User::_check_session_ticket($login, $session_ticket,
          $last_valid_timestamp, $current_timestamp);
         return $ticket_good;
         return true;
      }
      
      public function create_new_user($username, $password, $email) {
         $db_interface = new MySQLAdapterProjectManager();
         
         $command = "insert into e_mail values ";
      }
   
      public function authenticate ($login, $password) {
         $db_interface = new MySQLAdapterProjectManager();
         
         $valid_pass = User::check_password ($db_interface, $login, $password);
         return $valid_pass ? User::load_session_ticket($db_interface, $login) : '';
      }
      
      private function check_password($adapter, $login, $password) {
         $query = "select * from user where username = '$login' and password = '" . md5($password) . "'";
         $result = $adapter->db_get_first($query);
         if (isset($result['username']) && $result['username'] == $login) {
            return true;
         } else {
            return false;
         }
      }
      
      private function load_session_ticket ($db_interface, $login) {
         $issue_time = time();
         $ticket = md5($login . $issue_time);
         $ticket_set = User::set_server_session_ticket($db_interface, $ticket, $login, $issue_time);
         if ($ticket_set) {
            if (isset($this)) {
               $this->session_ticket = $ticket;
            }
            return $ticket;
         } else {
            $this->session_ticket = '';
            return '';
         }
      }
      
      private function set_server_session_ticket($adapter, $ticket, $login, $issue_time) {
         $command = "insert into ticket values ('$ticket', '$login', '$issue_time', '$issue_time')";
         $result = $adapter->db_command($command);
         return $result;
      }
      
      private function _check_session_ticket ($login, $session_ticket,
       $last_valid_timestamp, $timeout_minutes) {
         $adapter = new MySQLAdapterProjectManager();
         $current_timestamp = time();
         /* $query_string = "select check_ticket('$session_ticket', '$login', " .
          "$last_valid_timestamp, $current_timestamp)";   
         print "quer seen as: $query_string<br>\n";
         $result = $adapter->db_get_first($query_string);  */
         $result = $adapter->get_procedure_results('check_ticket', array('@ticket_count' => 'OUT',
         "'$session_ticket'" => 'IN', "'$login'" => 'IN', $last_valid_timestamp => 'IN', $current_timestamp => 'IN'));
         $count = isset($result['@ticket_count']) ? $result['@ticket_count'] : 0;
         return ($count > 0);
      }
      
      private function load_existing_user_info () {
         $db_interface = $this->db_interface;
         
         $fields = $db_interface->get_member_info($this->login);
         $this->given_name = $fields['given_name'];
         $this->surname = $fields['surname'];
         $this->e_mail = $fields['e_mail'];
         
         if ( !(isset($fields['given_name']) && isset($fields['surname'])
           && isset($fields['e_mail']) ) ||
          ($fields['given_name'] = '' || $fields['given_name'] = '' || $fields['given_name'] = '') ) {
            throw new Exception('Missing given name, surname or e-mail address.');
         }
      }
      
      public function change_password ($login, $old_password, $new_password) {
         $db_interface = $this->db_interface;
      
         if ($db_interface->check_password($login, $old_password)) {
            $success = $db_interface->change_password ($login, $old_password, $new_password);
            return ($success ? 'Password change succeeded' : 'Password change failed');
         } else {
            return('Existing paasword does not match');
         }
      }
      
      public function get_login () {
         return $this->login;
      }
      
      public function get_session_ticket () {
         return $this->session_ticket;
      }
      
      public function get_given_name () {
         return $this->given_name;
      }
      
      public function get_surname () {
         return $this->surname;
      }
      
      public function get_e_mail () {
         return $this->e_mail;
      }
      
      public function load_special_attribute ($attribute_name) {
         $db_interface = $this->db_interface;
         
         $fields = $db_interface->get_special_attribute ($this->login, $attribute_name);
         $this->profile[attribute_name] = $fields;
         return $fields;
      }
      
      public function load_special_attributes ($attribute_name) {
         $db_interface = $this->db_interface;
         
         $profile = array();
         $attributes = $db_interface->get_special_attributes($login);
   
         foreach($attributes as $attribute) {
            $key = $attribute['attribute_name'];
            $profile[$key] = array(
             'value' => $attribute['value'],
             'datatype' => $attribute['datatype']);
         }
         $this->profile = $profile;
      }
      
      public function get_special_attribute ($attribute_name) {
         return $this->profile[attribute_name];
      }
      
      public function set_session_ticket ($session_ticket) {
         $this->session_ticket = $session_ticket;
         
         if (!$given_name) {
            throw new Exception('Attempt to set empty ticket.');
         }
      }
      
      public function record_special_attribute ($attribute_name, $value, $quoted = TRUE,
       $type = 'string') {
         $db_interface = $this->db_interface;
         
         $success = $db_interface->set_special_attribute ($this->login, $attribute_name,
          $value, $quoted, $type);
         return $success;
      }
      
      public function delete () {
         $db_interface = $this->db_interface;
         
         $delete_success = $db_interface->delete($this->login);
         return $delete_success;
      }
   }

?>

