<?php
include_once('project_defs.php');
include_once('utilities.php');
include_once('MySQLAdapterProjectManager.php');
include_once('ProjectSpace.php');
include_once('User.php');

$action = $_POST['action'];
switch_on_action($action);

function switch_on_action($action) {
   $matches = array();
   if (preg_match('/^project_space-(.*)$/', $action, $matches)) {
      switch_action_on_project_space($matches[1]);
   } elseif (preg_match('/^project-(.*)$/', $action, $matches)) {
      switch_action_on_project($matches[1]);
   } elseif (preg_match('/person-(.*)$/', $action, $matches)) {
      switch_action_on_person($matches[1]);
   } elseif (preg_match('/user-(.*)$/', $action, $matches)) {
      switch_action_on_user($matches[1]);
   } else {
      switch_action_on_miscellaneous($action);
   }
}

function switch_action_on_project_space($action) {
   switch($action) {
      case 'create_new':
         create_new_project_space_and_owner();
      default:
   }
}

function create_new_project_space_and_owner() {
   $adapter = new MySQLAdapterProjectManager();
   
   $project_space_name = $adapter->db_escape($_POST['project_space_name']);
   $given_name = $adapter->db_escape($_POST['given_name']);
   $last_name = $adapter->db_escape($_POST['last_name']);
   $username = $adapter->db_escape($_POST['username']);
   $password = md5($_POST['password']);
   $email = $adapter->db_escape($_POST['email']);
   $first_name = $adapter->db_escape($_POST['first_name']);
   $middle_name = $adapter->db_escape($_POST['middle_name']);
   $person_results =
    create_new_person_object($adapter, $given_name, $last_name, $email, $first_name, $middle_name);
   $person_id = $person_results[0];
   $user_result = create_new_user($adapter, $person_id, $username, $password);
   $project_space_id = create_new_project_space($adapter, $username, $project_space_name);
   $visibility_result = make_new_owner_visible($adapter, $person_id, $project_space_id);
   mail_confirmation_to_owner($username, $email, $given_name, $last_name, $project_space_name);
   print "Project Space ID: $project_space_id\nPerson ID: $person_id\n";
}

function make_new_owner_visible($adapter, $person_id, $project_space_id) {
   $command = "insert into person_visible values($person_id, $project_space_id)";
   $result = $adapter->db_command($command);
   return $result;
}

function create_new_person_object($adapter, $given_name, $last_name, $email, $first_name, $middle_name) {
   $person = new Person($given_name, $last_name, 'e-mail', $first_name, $middle_name);
   $person_result = $person->save();
   $person_id = $person->get_person_id();
   $command = "insert into e_mail values ($person_id, '$email', true)";
   $result = $adapter->db_command($command);
   return array($person_id, $person_result, $result);
}

function create_new_user ($adapter, $person_id, $username, $password) {
   $command = "insert into user values('$username', '$password', $person_id)";
   $result = $adapter->db_command($command);
   return $result;
}

function create_new_project_space($adapter, $username, $project_space_name) {
   $description = $_POST['description'];
   $project_space = new ProjectSpace($project_space_name, $username, $description);
   $project_space->save();
   $project_space_id = $project_space->get_project_space_id();
   return $project_space_id;
}

function mail_confirmation_to_owner($username, $email, $given_name, $last_name, $project_space_name) {
   $to = "$given_name $last_name <$email>";
   $message = "You or someone using your email has reuested that your password be reset.\n" .
   $subject = "Project Space $project_space_name Created On Project Manager System";
   $message = "Dear $given_name $last_name,\n" .
   "A new project space has just been created by you at http://www.rjnewton.com/project_manger.\n" .
   "You are the owner of this space and may add new users as you need.\n" .
   "Your user name on the system is $username.\n";
   "The new password for $username is $new_pass\n" .
   "You may use this password to log in, then change the password.";
   $headers = 'From: Project Manager User Services <rjnewton@rjnewton.com>' . "\r\n" .
   'X-Mailer: PHP/' . phpversion();
   $mailed = mail($to, $subject, $message, $headers);
   return $mailed;
}

function switch_action_on_project($action) {
}

function switch_action_on_person($action) {
}

function switch_action_on_user($action) {
   switch($action) {
      case 'reset_password':
         reset_user_password();
         break;
      case 'authenticate':
         authenticate_and_issue_ticket();
         break;
      case 'change_password':
         change_password_for_user();
         break;
      default:
   }
}

function reset_user_password() {
   $adapter = new MySQLAdapterProjectManager();
   $email_tmp = $_POST['email'];
   $email = preg_replace('/%40/', '@', $email_tmp);
   $query = "select person.person_guid, person.name_given, person.name_last, user.username from " .
   "e_mail join person on e_mail.person_guid = person.person_guid " .
   "join user on user.person_guid = person.person_guid " .
   "where e_mail.e_mail = '$email'";
   $result = $adapter->db_get_first($query);
   if (!isset($result['username'])) {
      print "Sorry. name not found";
      return;
   }
   $username = $result['username'];
   $person_id = $result['person_guid'];
   $given_name = $result['name_given'];
   $last_name = $result['name_last'];
   $new_pass = get_random_password();
   reset_password_record($adapter, $username, $new_pass);
   mail_reset_password_to_user($username, $new_pass, $email, $given_name, $last_name);
   print "Your password has been successfully reset\n" .
   "You will recieve an e-mail message with your new password\n" .
   "You can then use the credentials provided to log in and\n" .
   "change your password to one you select\n";
}

function get_random_password() {
   $pass = '';
   srand(time());
   for ($i = 0; $i < 8; $i++) {
      $randval = rand(1, 62);
      if ($randval < 11) {
         $pass .= chr($randval + 47);
      } elseif ($randval < 37) {
         $pass .= chr($randval + 54);
      } else {
         $pass .= chr($randval + 60);
      }
   }
   return $pass;
}

function authenticate_and_issue_ticket() {
   $user = isset($_POST['user']) ? $_POST['user'] : '';
   $pass = isset($_POST['pass']) ? $_POST['pass'] : '';
   if (isset($_POST['user'])) {
      $ticket = User::authenticate($user, $pass);
      if (isset($ticket)) {
         print "\nTicket:$ticket\n";
      } else {
         print "Sorry, authenitcation failed";
      }
   }
}

function reset_password_record($adapter, $username, $new_pass) {
   $hashed_pass = md5($new_pass);
   $user = $adapter->db_escape($username);
   $command = "update user set password = '$hashed_pass' where username = '$user'";
/*   print "Command is\n$command\n";  */
   $result = $adapter->db_command($command);
   return $result;
}

function mail_reset_password_to_user($username, $new_pass, $email, $given_name, $last_name) {
   $to = "$given_name $last_name <$email>";
   $subject = 'Password Reset On Project Manager System';
   $message = "You or someone using your email has requested that your password on the Project " .
   "Manager system be reset.\n" .
   "The new password for $username is $new_pass\n" .
   "You may use this password to log in at [http:www.rjnewton.com/project_manager], then " .
   "use the \"Change Password\" button to change your password to one you select.";
   $headers = 'From: Project Manager User Services <rjnewton@rjnewton.com>' . "\r\n" .
   'X-Mailer: PHP/' . phpversion();
   $mailed = mail($to, $subject, $message, $headers);
}

function change_password_for_user() {
   $adapter = new MySQLAdapterProjectManager();
   
   $login = isset($_POST['login']) ? $_POST['login'] : '';
   $ticket = isset($_POST['ticket']) ? $_POST['ticket'] : '';
   $new_pass = isset($_POST['new_pass']) ? $_POST['new_pass'] : '';
   $hashed_pass = md5($new_pass);
   $command = "update user set password = '$hashed_pass' where username = '$login'";
   $result = $adapter->db_command($command);
   if ($result) {
      print 'password change succeeded';
   } else {
      print 'password change failed.  Sorry';
   }
}
   
   function ajax_create_person() {
      $given = $_POST['given'];
      $last = $_POST['last'];
      $first = $_POST['first'];
      $middle = $_POST['middle'];
      $contact_mode = $_POST['contact_mode'];
      $person = new Person($given, $last, $contact_mode, $first, $middle);
      $result_person = $person->save();
      $person_id = $person->get_person_id();
      $project_space = $_POST['project_space'];
      $result_association = make_person_available($person_id, $project_space);
      if ( isset($_POST['username']) && isset($_POST['email']) ) {
         $user_result = ajax_create_user($person_id, $given, $last);
         $email_result = ajax_create_email($person_id);
      }
      $person_insert_status = $result_person && $result_association ? 'succeeded' : 'failed';
      print "$person_insert_status User: $user_result E-Mail: $email_result\n";
   }
   
   function make_person_available($person_id, $project_space) {
      $adapter = new MySQLAdapterProjectManager();
      
      $query = "insert into person_visible values ($person_id, $project_space)";
      $result = $adapter->db_command($query);
      return $result;
   }
   
   function ajax_reload_persons_available() {
      if (isset($_POST['current_project_id'])) {
         load_people_available_but_not_on_current_project($_POST['current_project_id']);
      } else {
         load_people_by_current_project_space();
      }
      $select_innards = assemble_persons_available_options_html();
      exit($select_innards);
   }
   
   function ajax_create_user($person_id, $given, $last) {
      $adapter = new MySQLAdapterProjectManager();
      
      $username = $_POST['username'];
      if (!isset($_POST['email']) || $username == '') {
         return false;
      }
      $password = get_random_password();
      $hashed_pass = md5($password);
      $command = "insert into user values ('$username', '$hashed_pass', $person_id)";
      $result = $adapter->db_command($command);
      $this->_mail_notice_to_user($password, $given, $last);
      return $result;
   }
     
   function ajax_create_email($person_id) {
      $adapter = new MySQLAdapterProjectManager();
      
      $email = preg_replace('/%40/', '@', $_POST['email']);
      $clean_email = $adapter->db_escape($email);
      $command = "insert into e_mail value($person_id, '$clean_email', true)";
      $result = $adapter->db_command($command);
      return $email;
   }
   
   function mail_notice_to_user($password, $given, $last) {
      $email = $_POST['email'];
      $username = $_POST['username'];
      $to = "$given $last <$email>";
      $subject = 'Project Manager Login Information';
      list ($owner_given, $owner_last, $project_space_name) = 
       $this->_get_project_space_info();
      $message = "$owner_given $owner_last has created a user account for you in " .
      "the $project_space_name pool on the Project Manager site. [http://www.rjnewton.com/project_manager]" .
      "This will allow you to view and contribute to project\n" .
      "tracking information stored there.  Your credentials are:\n" .
      "User name: $username\n" .
      "Password: $password\n";
      $headers = "From: Project Manager User Services <rjnewton@efn.org>\r\n" .
      "X-mailer: PHP\r\n";
      mail($to, $subject, $message, $headers);
   }

   function get_project_space_info() {
      $adapter = new MySQLAdapterProjectManager();
      $query = 'select person.name_given, person.name_last, project_space.name as project_space_name ' .
      'from project_space join user on project_space.owner = user.username ' .
      'join person on user.person_guid = person.person_guid ' .
      'where project_space.project_space_guid = ' . $_POST['project_space'];
      print "Query to get space info is:\n$query\n";
      $result = $adapter->db_get_first($query);
      $owner_given = $result['name_given'];
      $owner_last = $result['name_last'];
      $project_space_name = $result['project_space_name'];
      return array($owner_given, $owner_last, $project_space_name);
   }

function switch_action_on_miscellaneous($action) {
}

?>
