<html>
<head>
   <title> Project Manager: Login and Account Creation </title>
   <meta name="Author" value="R. Joseph Newton">
   <link rel="shortcut icon" href="project_manager.ico" type="image/xicon">
   <style type="text/css" media="all">
      @import "project_manager.css";
      @import 'login_page.css';
   </style>
   <script type="text/javascript">
      function get_http_request_object() {
         var xmlHttp;
         try {
         // Firefox, Opera 8.0+, Safari
         xmlHttp=new XMLHttpRequest();
         }
         catch (e) {
         // Internet Explorer
            try {
               xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
            }
            catch (e)
          {
          try
               {
            xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
            }
          catch (e)
            {
            alert("Your browser does not support AJAX!");
            return false;
            }
          }
        }
        return xmlHttp;
      }
   </script>
</head>
<body>
   <div class="body">
      <div class="header" id="page-header">
         <div class="heading-logo" id="logo-top-left">
         </div>
         <div class="heading-logo" id="logo-top-right">
         </div>
         <div class="heading-text">
            <h3 class="page_heading" id="page_heading"> Project Manager Login </h3>
         </div>
      </div>
      
      <div class="content-login_page">
         <script type="text/javascript">
            function submit_credentials() {
               username = document.getElementById('input-login-user').value;
               password = document.getElementById('input-login-pass').value;
               client = get_http_request_object();
               client.open("POST", "ajax_server.php", true);
               client.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
               parameters = 'action=user-authenticate&user=' + username + '&pass=' + password;
               client.onreadystatechange = function () {
                  if(client.readyState==4) {
                     /* alert (client.responseText); */
                     msg = client.responseText.replace(/^[\n\s]*/, '');
                     msg2 = msg.replace(/[\s\n]*$/, '');
                     values = msg2.split(/\s*\:\s*/);
                     ticket = values[1];
                     document.getElementById('system-login').value = username;
                     document.getElementById('system-ticket').value = ticket;
                     document.getElementById('system-entry_form').submit();
                  }
               }
               client.send(parameters);
            }
         </script>
         <div class="login_pane">
            <div class="login_pane-upper">
               <form name="system-entry_form" id="system-entry_form" class="system-entry_form"
               action="./index.php" method="POST">
                  <input type="hidden" name="login" id="system-login" value="">
                  <input type="hidden" name="ticket" id="system-ticket" value="">
               </form>
               <form name="authentication_form" action="." method="POST" class="full-body" id="form-authentication">
                  <h3 class="column_header"> Log In </h3>
                  <table class="table-login" cols="2" rows="2">
                     <tr id="row-login">
                        <td class="login-label">
                           <label for="input-login-user"> User name: </label>
                        </td>
                        <td class="login-input">
                           <input type="text" class="input-login" id="input-login-user" name="user" />
                        </td>
                     </tr>
                     <tr id="row-password">
                        <td class="login-label">
                           <label for="input-login-pass"> Password </label>
                        </td>
                        <td class="login-input">
                           <input type="password" class="input-login" id="input-login-pass" name="pass" />
                        </td>
                     </tr>
                  </table>
                  <button type="button" class="button-login" onclick="submit_credentials();"> Log in </button>
               </form>
            </div>
            <div class="login_pane-lower" id="login_pane-lower">
               <script type="text/javascript">
                  function initiate_password_reset() {
                     e_mail = document.getElementById('forgotten-email').value;
                     clean_e_mail = e_mail.replace('/@/', '%40');
                     parameters = "action=user-reset_password&email=" + clean_e_mail;
                     client = get_http_request_object();
                     client.open("POST", "ajax_server.php", true);
                     client.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
                     client.onreadystatechange = function () {
                        if(client.readyState==4) {
			   response = client.responseText.replace(/^[\s\n]*/, '');
                           alert(response);
			   document.getElementById('forgotten-email').value = '';
                        }
                    /*    clear_new_project_space();   */
                     }
                     client.send(parameters);
                  }
               </script>
               <h3 class="column_header"> Forgotten Password? </h3>
               <p> If you have forgotten your password, enter your e-mail address below and click the "Request
               Password Reset" button.  A new randodmly-generated password will be set for your account, and will
               be e-mailed to you at the address you have entered. </p>
               <div>
                  Enter e-mail address here:
               </div>
               <div>
                  <input type="text" id="forgotten-email" name="forgotten-email">
               </div>
               <div>
                  <button type="button" onclick="initiate_password_reset()"> Request Password Reset </button>
               </div>
            </div>
         </div>
         <div class="account_creation">
            <script type="text/javascript">
               function enable_new_project_space() {
                  new_user_form = document.getElementById('wrapper-hidden_form');
                  document.getElementById('title-hidden_dialog').innerHTML = 'Create New Project Space';
                  new_user_form.style.zIndex = 7;
               }
            </script>
            <h3 class="column_header"> Create New Account </h3>
            <p> Create a new Project Space if you are beginning a new project group.  Once you have been registered,
            you will have a new Project Space in which to work.  You may then add new users to your project
            space and set their level of access.</p>
            
            <p class="notice"> If you are trying to join an existing project space, please log in to the left.
            See the owner of the project space for details, or click the "Request Password Reset" link. </p>
            <button type="button" id="new_project_space-activate" onclick="enable_new_project_space();"> Create New Project Space </button>
            
            <style type="text/css">
               @import 'hidden_form.css';
            </style>

         </div>
<?php
include_once('hidden_form.tmpl.php');
?>
      </div>
      <div class="footer" id="page-footer">
      <p class="application-title"> Project Manager </p>
      <p class="copyright-information"> &copy;2007 R. Joseph Newton -- all rights reserved. </p>
      <p class="support-information"> <span class="support-leader"> Support: </span> Joseph Newton <a href="mailto:rjnewton@efn.org"> e-mail: rjnewton@efn.org </a>
      </div>
   </div>
</body>
</html>
