<?php

/**
 * Name: project_defs.php
 * Author: R. Joseph Newton
 * Purpose: Provides bootstrap init variables for Project Manager package.
 * Last Modified: January 30, 2007
 */

define('FILES_PATH', '.');
define('INI_FILE', '../../adm/project.ini');

function get_ini_path() {
   return FILES_PATH . '/' . INI_FILE;
}

function get_ini_variables() {
   $arr_init = array();
   $fp = fopen(get_ini_path(), 'r');
   if (!$fp) {
      return false;
   }
   
   $line = '';
   while ( !feof($fp) ) {
      $line = fgets($fp);
      if ( preg_match('/^\[/', $line) ) {
         continue;
      }
      $trimmed_line = chop($line);
      if (!$trimmed_line) {
         continue;
      }
      list($name, $value) = split('\s*=\s*', $trimmed_line);
      $value = isset($value) ? $value : '';
      $arr_init[$name] = $value;
   }
   return $arr_init;
}

function get_ini_section($section_name) {
   $arr_section = array();
   $fp = fopen(get_ini_path(), 'r');
   if (!$fp) {
      return false;
   }
   
   $line = '';
   $pattern = "/^\[$section_name/i";
   $line = fgets($fp);
   while (!feof($fp) && !preg_match($pattern, $line) ) {
      $line = fgets($fp);
   }
   while ( !feof($fp) ) {
      $line = fgets($fp);
      $trimmed_line = chop($line);
      if ( !$trimmed_line || preg_match("#^\[/$section_name#i", $line) ) {
         break;
      }
      if (!$trimmed_line) {
         continue;
      }
      
      list($name, $value) = preg_split('/\s*=\s*/', $trimmed_line);
      $value = isset($value) ? $value : '';
      $arr_section[$name] = $value;
   }
   return $arr_section;
}

?>
