<?php
 /**
  * Name: state_maintenance_process.php
  * Author: R. Joseph Newton
  * Purpose: Provides state maintenance toolbox for HTML forms
  */

function reload_and_integrate_state_information() {
   $state = array();
   $submitted = array();
   foreach ($_POST as $name => $value) {
      if ($name != 'login' && $name != 'ticket') {
         $base_name = preg_replace('/^current_/', '', $name);
         $submitted[$base_name] = $value;
      }
   }
   update_state_with_submissions($state, $submitted);
   load_state_values_into_form_fields($state);
}
/*   OBSOLETE
function load_elements_into_proper_structures ($flat_name, $value, &$target_array) {
   if ( preg_match('/\[(\d+)\]$/', $flat_name) ) {
      $base_name = preg_replace('/\[\d+\]$/', '', $flat_name);
      if ( !isset($target_array[$base_name]) ) {
         $target_array[$base_name] = array();
      }
      $target_array[$base_name][] = $value;
      unset($target_array[$flat_name]);
   } else {
      $target_array[$flat_name] = $value;
   }
}                                          */

function update_state_with_submissions(&$state_array, &$submissions_array) {
   if (isset($submissions_array['action']) &&  ($submissions_array['action'] == 'Select project') &&
   isset($submissions_array['selected_project_id'])) {
      $submissions_array['project_id'] = $submissions_array['selected_project_id'];
      unset($submissions_array['selected_project_id']);
   }
   foreach ($submissions_array as $name => $value) {
      if ( isset($state_array[$name]) ) {
         unset($state_array[$name]);
      }
      $state_array[$name] = $value;
   }
}

function load_state_values_into_form_fields(&$state_array) {
   foreach ($state_array as $name => $value) {
      if ( is_array($value) ) {
         foreach ($value as $index => $subvalue) {
            print "\n   <input type=\"hidden\" name=\"current_" .$name . "[$index]" . "\" value=\"$subvalue\">";
         }
      } else {
         print "\n   <input type=\"hidden\" name=\"current_" . "$name\" value=\"$value\">";
      }
   }
   print "\n";
}

?>
