<?php /* user_interface.tmpl.php */ ?>
<html>
<head>
   <?php $manager = new ProjectManager(); ?>
   <title> <?php
               print "$page_title";
               $project_space_id = $manager->get_current_project_space_id();
               $pid = $manager->get_current_project_id();
               $project_name = $manager->get_current_project_name();
               if ( isset($project_name) && $project_name ) {
                  print "--$project_name";
               }
               if ( isset($active_process) && $active_process ) {
                  print ":  $active_process";
               }
            ?>
   </title>
   <meta name="Author" value="R. Joseph Newton">
   <link rel="shortcut icon" href="project_manager.ico" type="image/xicon">
   <style type="text/css" media="all">@import "project_manager.css";</style>
</head>
<body>
   <div class="body">
      <div class="header" id="page-header">
         <div class="heading-logo" id="logo-top-left">
         </div>
         <div class="heading-logo" id="logo-top-right">
         </div>
         <div class="heading-text">
            <h3 class="page_heading" id="page_heading"> <?php print $page_title; ?> </h3>
            <?php
               $project_name = $manager->get_current_project_name();
               if ( isset($project_name) ) {

                  print "<h2 class=\"subhead-project\"> $project_name </h2>\n";
               }
               if ( isset($active_process) ) {
                  $process_heading = ucwords($active_process);
                  print '            ' .
                   "<h3 class=\"process-heading\">  $process_heading <h3>\n";
               }
               
            ?>
            
         </div>
      </div>
      
      <form name="management_form" action="index.php" method="POST" class="full-body" id="mainform">
      <div class="menu_bar" name="menu_bar-main" id="menu_bar-main">
         <script type="text/javascript">
            function present_user_options() {
               document.getElementById('hidden_password_change').style.zIndex = 7;
            }
         </script>
         <button type="button" class="button-menu_bar-main" id="menu_ber-options" onclick="present_user_options()">
            User Options
         </button>
      </div>
      <div class="hidden_password_change" name="hidden_password_change" id="hidden_password_change">
         <script type="text/javascript">
            function change_user_password() {
               new_pass = document.getElementById('input-new_pass-new_pass').value;
               repeat_pass = document.getElementById('input-new_pass-repeat_pass').value;
               if (new_pass == '' || repeat_pass == '') {
                  alert('You must enter the new password and repeat the entry.');
                  return;
               }
               if (new_pass != repeat_pass) {
                  alert('Passwords enetered must match exactly.');
               }
               login = document.getElementById('system-login').value;
               ticket = document.getElementById('system-ticket').value;
               do_ajax_password_change(login, ticket, new_pass);
               close_new_pass_dialog();
            }
            
            function do_ajax_password_change(login, ticket, new_pass) {
               client = get_http_request_object();
               
               client = get_http_request_object();
               parameters = 'login=' + login + '&ticket=' + ticket + '&action=user-change_password&new_pass=' + new_pass;
               client.open("POST", "ajax_server.php", true);
               client.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
               client.onreadystatechange = function () {
                  if(client.readyState==4) {
                     if (client.responseText != '') {
                        response = client.responseText.replace(/^[\s]*password change\s*/, '');
                        if (response.match(/^succeeded/)) {
                           alert('Password succesfully changed');
                        } else {
                           alert("Password change failed.  Server responded:\n" + client.responseTex);
                        }
                     } else {
                     }
                  }
               }
               client.send(parameters);
            }
            
            function close_new_pass_dialog() {
               document.getElementById('input-new_pass-new_pass').value = '';
               document.getElementById('input-new_pass-repeat_pass').value = '';
               document.getElementById('hidden_password_change').style.zIndex = -7;
            }
         </script>
         <div class="header-dialog" id="title-hidden_dialog">
            Change Password
         </div>
         <table class="table-password_change" cols="2">
            <tr id="row-new_pass">
               <td class="new_pass-label">
                  <label for="input-new_pass-new_pass" class="new_pass"> New Password: </label>
               </td>
               <td class="new_pass-input">
                  <div class="input-wrapper required">
                     <input type="password" class="input-new_pass required" id="input-new_pass-new_pass" name="new_pass" />
                  </div>
               </td>
            </tr>
            <tr id="row-repeat_pass">
               <td class="new_pass-label">
                  <label for="input-new_pass-repeat_pass" class="new_pass"> Repeat Password: </label>
               </td>
               <td class="new_pass-input">
                  <div class="input-wrapper required">
                     <input type="password" class="input-new_pass required" id="input-new_pass-repeat_pass" name="repeat_pass" />
                  </div>
               </td>
            </tr>
         </table>
         <div class="name-whole-wrapper">
            <div class="name-entry-button-wrapper">
               <button type="button" class="submit-new_pass" name="new_pass_submit"
                id="new_pass_submit" onclick="change_user_password();">
                  Change Password
               </button>
            </div>
             <div class="name-entry-button-wrapper">
               <button type="button" class="submit-new_pass" name="new_pass_cancel"
                id="new_pass_cancel" onclick="close_new_pass_dialog();">
                  Cancel
               </button>
             </div>
          </div>
         
      </div>
<?php
   include_once('state_maintenance_process.php');
   $login = isset($_POST['login']) ? $_POST['login'] : '';
   $ticket = isset($_POST['ticket']) ? $_POST['ticket'] : '';
   print "         <input type=\"hidden\" name=\"login\" id=\"system-login\"  value=\"$login\">\n";
   print "         <input type=\"hidden\" name=\"ticket\" id=\"system-ticket\" value=\"$ticket\">\n";
   reload_and_integrate_state_information();
   print "         <input type=\"hidden\" name=\"project_space\" value=\"$project_space_id\">\n";
   print "         <input type=\"hidden\" name=\"project_name\" value=\"$project_name\">\n";
   include_once($current_template);
?>
      </form>
   
      <style type="text/css">
         @import 'hidden_form.css';
      </style>
<?php
   include_once('hidden_form.tmpl.php');
?>

      <div class="footer" id="page-footer">
      <p class="application-title"> Project Manager </p>
      <p class="copyright-information"> &copy;2007 R. Joseph Newton -- all rights reserved. </p>
      <p class="support-information"> <span class="support-leader"> Support: </span> Joseph Newton <a href="mailto:rjnewton@efn.org"> e-mail: rjnewton@efn.org </a>
      </div>
   </div>
</body>
</html>

